<?php
defined('IN_COPPERMINE') or die('Not in Coppermine...');

if ($CONFIG['thumbnail_to_fullsize']==1 && (defined('THUMBNAILS_PHP') || defined('INDEX_PHP'))) {
	define('USE_FANCYBOX', 1);
} elseif ($CONFIG['thumbnail_to_fullsize']!=1 && (defined('DISPLAYIMAGE_PHP'))) {
	define('USE_FANCYBOX', 2);
} else define('USE_FANCYBOX', 0);

// check whether file type is something fancybox can't handle - returns true if it can't display the file
function plg_fancybox_cantDo ($fnam, &$ftyp)
{
	$ftyp = cpg_get_type($fnam);
	return !in_array($ftyp['content'], ['image','movie']);
}

// build a data structure for fancybox from picture data
function plg_fancybox_object ($row, $cfg)
{
	if (plg_fancybox_cantDo($row['filename'], $ftyp)) return [];

	$url = get_pic_url($row, ($cfg['dspsize']=="I" ? 'normal' : 'fullsize'));
	if ($cfg['dspsize'] == $cfg['downs']) {
		$durl = $url;
	} elseif ($cfg['down']) {
		$durl = get_pic_url($row, ($cfg['downs']=="I" ? 'normal' : 'fullsize'));
	}
	$obj = [
		'pid' => $row['pid'],
		'src' => $url,
		'type' => $ftyp['content']=='movie' ? 'video' : 'image'
		];
	if ($cfg['down']) {
		$obj['opts']['image']['src'] = $durl;	//for download
	}
	$txtinfo = '';
	if (!empty($cfg['dsptxtt'])) $txtinfo .= trim($row['title']);
	if (!empty($cfg['dsptxtd'] && trim($row['caption']))) $txtinfo .= ($txtinfo ? ' ... ' : '') . trim($row['caption']);
	if ($txtinfo) $obj['opts']['caption'] = bb_decode($txtinfo);
	return $obj;
}

// get config based on user group id
function plg_fancybox_getcfg ()
{
	global $USER_DATA, $CONFIG;
	$gcfg = 'plg_fancybox_cfg'.$USER_DATA['group_id'];
	if (isset($CONFIG[$gcfg])) return json_decode($CONFIG[$gcfg], true);
	return json_decode($CONFIG['plg_fancybox_cfg'], true);
}

// build a list of album images and pass it on to the FancyBox js
function plg_fancybox_buildList ($aid)
{
	global $CONFIG, $USER, $superCage, $JS;

	// in case there are smilies involved we have to temporarily disable it 
	$es = $CONFIG['enable_smilies'];
	$CONFIG['enable_smilies'] = 0;
	if ($superCage->get->keyExists('album')) {
		$album = $superCage->get->testAlpha('album') ? $superCage->get->getAlpha('album') : $superCage->get->getInt('album');
	} else $album = $aid;
	if (in_array($album, ['lastupby','lastcomby']) && $superCage->get->keyExists('uid')) {
	    $USER['uid'] = $superCage->get->getInt('uid');
	}
	$CONFIG['FBMV'] = true;	// so lazy-load plugin won't muck with urls
	get_meta_album_set($superCage->get->getInt('cat'));
	$count = 0;
	$album_name = '';
	$rowset = get_pic_data($album, $count, $album_name, 0, 3000);	// limit to 3000
	if ($rowset) {
		$cfg = plg_fancybox_getcfg();
		foreach ($rowset as $row) {
			$fileentry = plg_fancybox_object($row, $cfg);
			if ($fileentry) $filelist[] = $fileentry;
		}
	}
	$JS['vars']['fb_imagelist'] = $filelist;
	// remove the lazy-load notifier
	unset($CONFIG['FBMV']);
	// restore the smilies setting
	$CONFIG['enable_smilies'] = $es;
}


$thisplugin->add_filter('gallery_header','plg_fancybox_deploy');
// include things need to run fancybox
function plg_fancybox_deploy ($data)
{
	global $JS;
	if (USE_FANCYBOX) {
		js_include('plugins/fancybox/fb/jquery.fancybox.min.js');
		js_include('plugins/fancybox/fancybox.js');
		$cfg = plg_fancybox_getcfg();
		$btns = ['zoom','slideShow','fullScreen'];
		if ($cfg['down']) $btns[] = 'download';
		$btns[] = 'thumbs';
		$btns[] = 'close';
		$opts = ['buttons'=>$btns,'loop'=>false,'cnthit'=>$cfg['cnthit']?true:false, 'keyboard'=>false];
		$opts['transitionEffect'] = 'slide';
		$opts['transitionDuration'] = 1500;
		if ($cfg['protect']) $opts['protect'] = true;
		$JS['vars']['fb_options'] = $opts;
		// build a list of items for thumbnails view
		if (defined('THUMBNAILS_PHP')) {
			plg_fancybox_buildList(null);
		}
	}
	return $data;
}


$thisplugin->add_filter('page_meta','plg_fancybox_meta');
// include the fancybox CSS
function plg_fancybox_meta ($html)
{
	if (USE_FANCYBOX) {
		$cfg = plg_fancybox_getcfg();
		return $html . '<link rel="stylesheet" type="text/css" href="plugins/fancybox/fb/jquery.fancybox.min.css" />'
		.'<style>.fancybox-content {border: 4px solid #FFF; border-radius: 4px;} .fancybox-is-open .fancybox-bg {opacity: '.($cfg['bgop'] ?: '0.9').'}</style>';
	} else return $html;
}


$thisplugin->add_filter('theme_display_thumbnails_params','plg_fancybox_thm_prms');
// replace linkage with fancybox calls
function plg_fancybox_thm_prms ($prms)
{
	global $CONFIG, $FORBIDDEN_SET;
	if (USE_FANCYBOX==1) {
		// get the filename from the thumb image alt property
		if (preg_match('#alt="([^"]+)"#', $prms['{THUMB}'], $matches)) {
			if (plg_fancybox_cantDo($matches[1],$ftyp)) return $prms;
		} else return $prms;

		$regx = '#.+MM_.+pid=(\d+).+width=(\d+).+height=(\d+)#';
		if (defined('THUMBNAILS_PHP')) {
			if (preg_match($regx, $prms['{LINK_TGT}'], $matches)) {
				$prms['{LINK_TGT}'] = 'javascript:;" onclick="plg_FBox.open(event,'.$matches[1].');';
			}
		}
		if (defined('INDEX_PHP')) {
			if (preg_match($regx, $prms['{LINK_TGT}'], $matches)) {
				$pid = $matches[1];
				$cfg = plg_fancybox_getcfg();
				$dat = cpg_db_query("SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS p WHERE pid='$pid' $FORBIDDEN_SET")->fetchAssoc(true);
				$CONFIG['FBMV'] = true;	// so lazy-load plugin won't muck with urls
				$fbdata = plg_fancybox_object($dat, $cfg);
				unset($CONFIG['FBMV']);
				if ($fbdata) $prms['{LINK_TGT}'] = 'javascript:;" data-fbdat=\''.json_encode($fbdata).'\' onclick="plg_FBox.one(event,this);';
			}
		}
	}
	return $prms;
}


if (USE_FANCYBOX==2) {
	// Add a filter for full image pop-up
	$thisplugin->add_filter('file_data','plg_fancybox_picture');
}
// Image pop-up substitute with FancyBox
function plg_fancybox_picture ($html)
{
	global $CONFIG;

	if ($CONFIG['allow_unlogged_access'] == 3 || (USER_ID && $CONFIG['allow_unlogged_access'] <= 2)) {
		// get the list of album pics and provide it to the FB js
		plg_fancybox_buildList ($html['aid']);
		// get the FB config
		$cfg = plg_fancybox_getcfg();
		$rpl = 'onclick="plg_FBox.open(event,'.$html['pid'].');"';
		$htm = $html['html'];
		$rex = '#onclick="(?=.*?MM_)[^"]+"#';
		if (preg_match($rex, $htm)) {
			$html['html'] = preg_replace($rex, $rpl, $htm);
		} else {
			$html['html'] = '<a href="javascript:;" '.$rpl.'>'.$htm.'</a>';
		}
		return $html;
	} else {
		if (!USER_ID && $CONFIG['allow_unlogged_access'] <= 2) {
			$html['html'] = $CURRENT_PIC_DATA['html'];
			return $html;
		}
	}
}


/** INSTALL/UNINSTALL **/

$thisplugin->add_action('plugin_install', 'plg_fancybox_install');
function plg_fancybox_install ()
{
	global $CONFIG, $superCage;
	if (empty($CONFIG['plg_fancybox_cfg'])) {
		$cfg = ['dspsize'=>'F','bgop'=>0.85,'cnthit'=>false,'down'=>false,'downs'=>'F','protect'=>false];
		cpg_config_set('plg_fancybox_cfg', json_encode($cfg), true);
	}
	return true;
}

$thisplugin->add_action('plugin_uninstall', 'plg_fancybox_uninstall');
function plg_fancybox_uninstall ()
{
	global $CONFIG, $superCage;
	if ($superCage->post->keyExists('plg_fb_submit') && $superCage->post->keyExists('uiType')) {
		if ($superCage->post->getInt('uiType') == 1) {
			cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name LIKE 'plg_fancybox_cfg%'");
		}
		return true;
	} else {
		return 1;
	}
}

$thisplugin->add_action('plugin_cleanup', 'plg_fancybox_cleanup');
function plg_fancybox_cleanup ($val)
{
	global $lang_common, $superCage, $lang_plugin_fancybox;

	echo '<form name="cpgform" id="cpgform" action="'.$superCage->server->getEscaped('REQUEST_URI').'" method="post">';
	echo <<<EOT
	<br />{$lang_plugin_fancybox['uninType']}<br />
	<input type="radio" name="uiType" id="uiFull" value="1" style="margin-left:2em" checked="checked" /> <label for="uiFull">{$lang_plugin_fancybox['fullUnin']}</label><br />
	<input type="radio" name="uiType" id="uiPart" value="2" style="margin-left:2em" /> <label for="uiPart">{$lang_plugin_fancybox['partUnin']}</label><br />
	<br /><input type="submit" name="plg_fb_submit" value="{$lang_common['continue']}" class="button" style="padding:2px 8px" />
	</form>
EOT;
}
//EOF