'use strict';
/* globals $,js_vars*/
var plg_FBox = (function() {
	let wv = {};
	return {
		open: (evt,pID) => {
			if (evt.altKey) {
				window.location = 'displayimage.php?pid=' + pID;
			} else {
				let found = js_vars.fb_imagelist.findIndex(pic => pic.pid == pID);
				$.fancybox.open(js_vars.fb_imagelist, js_vars.fb_options, found);
			}
		},
		one: (evt,elm) => {
			let obj = JSON.parse(elm.dataset.fbdat);
			if (evt.altKey) {
				window.location = 'displayimage.php?pid=' + obj.pid;
			} else {
				$.fancybox.open(obj, js_vars.fb_options);
			}
		},
		key: (evt) => {
			if ($('.fancybox-container.fancybox-is-open').length > 0) {
				let kC = evt.keyCode;
				if ([8,27,37,38,39,40].includes(kC)) {
					evt.preventDefault();
					evt.stopPropagation();
					let fb = $.fancybox.getInstance();
					switch (kC) {
						case 8:
						case 27:
							fb.close(evt);
							break;
						case 37:
						case 38:
							if (evt.shiftKey) fb.jumpTo(0);
							else fb.previous(evt);
							break;
						case 39:
						case 40:
							if (evt.shiftKey) fb.jumpTo(fb.group.length - 1);
							else fb.next(evt);
							break;
					}
				}
			}
		},
		hit: (pid) => {
			if (!wv[pid]) {
				wv[pid] = true;
				$.get('index.php?file=fancybox/cnthit&p=' + pid);
			}
		}
	};
})();

document.addEventListener('keydown', plg_FBox.key, true);

$(document).on('afterShow.fb', function (evt,inst,item) {
	if (inst.opts.cnthit) plg_FBox.hit(item.pid);
});
